#include <stdlib.h>
#include <stdio.h>
#define MAXX 100
#define MAXY 100

int X, Y;
char tmp[1000];
int x1,y1,x2,y2;

char pole[MAXX][MAXY];
int i,j,k,l,m;

void swpmin(int* a, int *b){
    int pom;
    if(*b<*a){
	pom=*a;
	*a=*b;
	*b=pom;
    }
}

void swp(int* a, int *b){
    int pom;
	pom=*a;
	*a=*b;
	*b=pom;
}


void putline(int x1,int y1,int x2,int y2){
    if (x1==x2){
	swpmin(&y1, &y2);
	for(i=y1;i<=y2;i++){
	    switch(pole[x1][i]){
		case ' ':
		case '|': 
		    pole[x1][i]='|';
		    break;
		case '-': 
		case '+': 
		    pole[x1][i]='+';
		    break;
		default:
		    pole[x1][i]='*';			
	    }
	}
    }
    else if(y1==y2){
	swpmin(&x1, &x2);
	for(int i=x1;i<=x2;i++){
	    switch(pole[i][y1]){
		case ' ':
		case '-': 
		    pole[i][y1]='-';
		    break;
		case '|':
		case '+': 
		    pole[i][y1]='+';
		    break;
		default:
		    pole[i][y1]='*';			
	    }
	}
    }
    else{
	if (x1>x2){swp(&x1,&x2);swp(&y1,&y2);}
//	printf("uvnitr %d %d %d %d\n",x1,y1,x2,y2); 
	if(y1<y2){
	    for(i=0;i<=(x2-x1);i++){
    		switch(pole[x1+i][y1+i]){
		    case ' ':
		    case '\\': 
			pole[x1+i][y1+i]='\\';
			break;
		    case '/': 
		    case 'x': 
			pole[x1+i][y1+i]='x';
		        break;
		    default:
			pole[x1+i][y1+i]='*';			
		}
	    }
	}
	else{
	    for(i=0;i<=(x2-x1);i++){
    		switch(pole[x1+i][y1-i]){
		    case ' ':
		    case '/': 
			pole[x1+i][y1-i]='/';
			break;
		    case '\\': 
		    case 'x': 
			pole[x1+i][y1-i]='x';
		        break;
		    default:
			pole[x1+i][y1-i]='*';			
		}
	    }
	}
    }
}

void puttext(int x1,int y1,char *tmp){
 while(*tmp){
// printf("x1==%d y1==%d X==%d Y==%d s==%s\n",x1,y1,X,Y,tmp);
    if (x1<=X && y1<=Y){
	if(pole[x1][y1]==' ' || pole[x1][y1]==tmp[0]){
	    pole[x1][y1]=tmp[0];
	}
	else{
	    pole[x1][y1]='*';
	}
    }
    tmp++;
    x1++;
 }
}

void putclear(int x1,int y1,int x2,int y2){
 swpmin(&x1,&x2);
 swpmin(&y1,&y2);
 for (i=x1;i<=x2;i++)
  for (j=y1;j<=y2;j++)
    pole[i][j]=' ';
}

void putpoint(int x1,int y1){
 if (pole[x1][y1]==' ' || pole[x1][y1]=='o'){
    pole[x1][y1]='o';
 } 
 else{
    pole[x1][y1]='*';
 }
}


int main(void){
    for(;;){
	scanf("%d %d\n", &X,&Y);
	if (X==0 && Y==0) break;
	for (i=0;i<X+1;i++)
	    for (j=0;j<Y+1;j++)
		pole[i][j]=' ';
	for (i=0;i<=X+1;i++){
	 pole[i][0]='-';
	 pole[i][Y+1]='-';
	}		
	for (j=0;j<=Y+1;j++){
	 pole[0][j]='|';
	 pole[X+1][j]='|';
	}		
	pole[0][0]='+';
	pole[0][Y+1]='+';
	pole[X+1][0]='+';
	pole[X+1][Y+1]='+';
	do{
	    scanf("%s",tmp);
	    if(!strcmp(tmp,"PRINT")) break;
	    switch (tmp[0]){
		case 'L':
		    scanf("%d %d %d %d\n", &x1,&y1,&x2,&y2);
//		    printf("line %d %d %d %d\n", x1,y1,x2,y2);
		    putline(x1,y1,x2,y2);
		    break;
		case 'T':
		    scanf("%d %d %s\n", &x1,&y1,tmp);
//		    printf("text %d %d %s\n", x1,y1,tmp);
		    puttext(x1,y1,tmp);
		    break;
		case 'C':
		    scanf("%d %d %d %d\n", &x1,&y1,&x2,&y2);
//		    printf("clear %d %d %d %d\n", x1,y1,x2,y2);
		    putclear(x1,y1,x2,y2);
		    break;
		case 'P':
		    scanf("%d %d\n", &x1,&y1);
//		    printf("point %d %d\n", x1,y1);
		    putpoint(x1,y1);
	    }
	}while(1);
	scanf("\n");
        for (j=0;j<=Y+1;j++){
	    for (i=0;i<=X+1;i++)
		printf("%c", pole[i][j]);
	    printf("\n");
	}
	printf("\n");
    }
    return 0;
}
